/*----- PROTECTED REGION ID(Daresbury.h) ENABLED START -----*/
//=============================================================================
//
// file :        Daresbury.h
//
// description : Include file for the Daresbury class
//
// project :     Daresbury
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef Daresbury_H
#define Daresbury_H

#include <tango.h>
#include <MailSender.h>

#define MAX_MODS 22
#define MAX_LOG  100

typedef struct {
  long   log_time;
  string reason;
  short  itlk[MAX_MODS];
} ItlkLog;

typedef struct {
  Tango::DevBoolean enabled_sms;
  Tango::DevBoolean sms_sent;
  Tango::DevState   last_state;
  time_t            alarm_time;
} ItlkAlarm;

/*----- PROTECTED REGION END -----*/	//	Daresbury.h

#ifdef TANGO_LOG
	// cppTango after c934adea (Merge branch 'remove-cout-definition' into 'main', 2022-05-23)
	// nothing to do
#else
	// cppTango 9.3-backports and older
	#define TANGO_LOG       cout
	#define TANGO_LOG_INFO  cout2
	#define TANGO_LOG_DEBUG cout3
#endif // TANGO_LOG

/**
 *  Daresbury class description:
 *    Handle PSS crate hardware
 */


namespace Daresbury_ns
{
/*----- PROTECTED REGION ID(Daresbury::Additional Class Declarations) ENABLED START -----*/

//	Additional Class Declarations

/*----- PROTECTED REGION END -----*/	//	Daresbury::Additional Class Declarations

class Daresbury : public TANGO_BASE_CLASS
{

/*----- PROTECTED REGION ID(Daresbury::Data Members) ENABLED START -----*/

//	Add your own data members
protected:
	void  save_property(char *name,char *value);
	void  save_description(int address,int bit);
	void  load_descriptions(int address);
	void  save_alarm(int address,int bit);
	void  load_alarms(int address);
	void  check_alarm(short state,int module,int relay);
	void  initialise_pscom();
  void  send_cmd(char *cmd, char *argout);
  void  write_cmd(char *cmd, char *argout);
	short compact_state(int module,int relay,short state);
	Tango::DevState get_relay_state(short state);
  void  msleep(int ms);
	long  get_ticks();
	void  add_log(string reason);
	
	Tango::DeviceProxy *theSerial;
	Tango::DeviceProxy *smsDevice;
	MailSender         *mailSender;
	ItlkLog            *logs;
	int                 nb_log;
	ItlkAlarm           alarms[MAX_MODS*8];
	long                start_time;
	char               *descriptions[MAX_MODS*8];
	char                last_response[2048];
	string              smsNumber;

/*----- PROTECTED REGION END -----*/	//	Daresbury::Data Members

//	Device property data members
public:
	//	Serial_line:	Name of the serial line device
	std::string	serial_line;
	//	Init_pscom:	Flag to force reinitialisation (This is needed on certain old daresbury board)
	//  Default is 0 => no initialisation
	Tango::DevShort	init_pscom;

//	Attribute data members
public:
	Tango::DevShort	*attr_Interlocks_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Daresbury(Tango::DeviceClass *cl,std::string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Daresbury(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	Daresbury(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~Daresbury();


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Read the device properties from database
	 */
	void get_device_property();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();


//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method     : Daresbury::read_attr_hardware()
	 *	Description: Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(std::vector<long> &attr_list);

/**
 *	Attribute Interlocks related methods
 *
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Spectrum max = 1024
 */
	virtual void read_Interlocks(Tango::Attribute &attr);
	virtual bool is_Interlocks_allowed(Tango::AttReqType type);


	//--------------------------------------------------------
	/**
	 *	Method     : Daresbury::add_dynamic_attributes()
	 *	Description: Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:
	/**
	 *	Command State related method
	 *	Description: This command gets the device state (stored in its device_state data member) and returns it to the caller.
	 *
	 *	@returns Device state
	 */
	virtual Tango::DevState dev_state();
	/**
	 *	Command DevRead related method
	 *	Description: Returns the response of the PSS hardware.
	 *
	 *	@returns Serial line response
	 */
	virtual Tango::DevString dev_read();
	virtual bool is_DevRead_allowed(const CORBA::Any &any);
	/**
	 *	Command GetAllDescription related method
	 *
	 *
	 *	@returns List of interlock description
	 */
	virtual Tango::DevVarStringArray *get_all_description();
	virtual bool is_GetAllDescription_allowed(const CORBA::Any &any);
	/**
	 *	Command GetHistoryInfo related method
	 *	Description: Returns a list of known logs.
	 *
	 *	@returns Return a list of interlock logs [date,reason]
	 */
	virtual Tango::DevVarLongStringArray *get_history_info();
	virtual bool is_GetHistoryInfo_allowed(const CORBA::Any &any);
	/**
	 *	Command GetInterlockDescription related method
	 *
	 *
	 *	@param argin List of Interlock addresses : [Word address,Bit address]*
	 *	@returns Interlock descrition string array
	 */
	virtual Tango::DevVarStringArray *get_interlock_description(const Tango::DevVarLongArray *argin);
	virtual bool is_GetInterlockDescription_allowed(const CORBA::Any &any);
	/**
	 *	Command GetInterlockState related method
	 *
	 *
	 *	@param argin List of Interlock addresses : [Word address,Bit address]*
	 *	@returns List of interlock state
	 */
	virtual Tango::DevVarCharArray *get_interlock_state(const Tango::DevVarLongArray *argin);
	virtual bool is_GetInterlockState_allowed(const CORBA::Any &any);
	/**
	 *	Command ReadInterlockHistory related method
	 *	Description: Returns the states of the interlock set of the specified log
	 *
	 *	@param argin Log time , see GetHistoryInfo
	 *	@returns Array of interlock
	 */
	virtual Tango::DevVarShortArray *read_interlock_history(Tango::DevLong argin);
	virtual bool is_ReadInterlockHistory_allowed(const CORBA::Any &any);
	/**
	 *	Command Reset related method
	 *	Description: Reset the interlock system.
	 *
	 */
	virtual void reset();
	virtual bool is_Reset_allowed(const CORBA::Any &any);
	/**
	 *	Command SetInterlockDescription related method
	 *	Description: Sets the descripton of the specified interlock.
	 *
	 *	@param argin argin[0]=Word address
	 *	argin[1]=Bit address
	 *	argin[2]=Interlock description
	 */
	virtual void set_interlock_description(const Tango::DevVarStringArray *argin);
	virtual bool is_SetInterlockDescription_allowed(const CORBA::Any &any);
	/**
	 *	Command EnableSMS related method
	 *	Description: Enable SMS alarm for the specified interlock.
	 *
	 *	@param argin argin[0]=Word address
	 *	argin[1]=Bit address
	 */
	virtual void enable_sms(const Tango::DevVarLongArray *argin);
	virtual bool is_EnableSMS_allowed(const CORBA::Any &any);
	/**
	 *	Command DisableSMS related method
	 *	Description: Disable SMS alarm for the specified interlock.
	 *
	 *	@param argin argin[0]=Word address
	 *	argin[1]=Bit address
	 */
	virtual void disable_sms(const Tango::DevVarLongArray *argin);
	virtual bool is_DisableSMS_allowed(const CORBA::Any &any);
	/**
	 *	Command GetSMS related method
	 *
	 *
	 *	@param argin argin[0]=Word address
	 *	argin[1]=Bit address
	 *	@returns true if the SMS alarm is enabled for this interlock, false otherwise.
	 */
	virtual Tango::DevBoolean get_sms(const Tango::DevVarLongArray *argin);
	virtual bool is_GetSMS_allowed(const CORBA::Any &any);


	//--------------------------------------------------------
	/**
	 *	Method     : Daresbury::add_dynamic_commands()
	 *	Description: Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(Daresbury::Additional Method prototypes) ENABLED START -----*/

//	Additional Method prototypes

/*----- PROTECTED REGION END -----*/	//	Daresbury::Additional Method prototypes
};

/*----- PROTECTED REGION ID(Daresbury::Additional Classes Definitions) ENABLED START -----*/

//	Additional Classes Definitions

/*----- PROTECTED REGION END -----*/	//	Daresbury::Additional Classes Definitions

}	//	End of namespace

#endif   //	Daresbury_H
